module b01(
    line1,
    line2,
    rst,
    outp,
    overflw,
    clock
);
    input line1;
    input line2;
    input rst;
    output outp;
    output overflw;
    input clock;
    reg outp;
    reg overflw;
    reg [2:0]stato;
always @ (  posedge clock)
begin
    if (!rst) begin
        stato = 0;
        outp<= 0;
        overflw <= 1'b0;
    end

    else
    begin

        case ( stato ) 
            0:
            begin
                if ( line1 == 1'b1 & line2 == 1'b1 ) 
                begin
                    stato = 4;
                end
                else
                begin 
                    stato = 1;
                end
                outp <= line1 ^ line2;
                overflw <= 1'b0;
            end
            3:
            begin
                if ( line1 == 1'b1 & line2 == 1'b1 ) 
                begin
                    stato = 4;
                end
                else
                begin 
                    stato = 1;
                end
                outp <= line1 ^ line2;
                overflw <= 1'b1;
            end
            1:
            begin
                if ( line1 == 1'b1 & line2 == 1'b1 ) 
                begin
                    stato = 5;
                end
                else
                begin 
                    stato = 2;
                end
                outp <= line1 ^ line2;
                overflw <= 1'b0;
            end
            4:
            begin
                if ( line1 == 1'b1 | line2 == 1'b1 ) 
                begin
                    stato = 5;
                end
                else
                begin 
                    stato = 2;
                end
                outp <=  ~( line1 ^ line2);
                overflw <= 1'b0;
            end
            2:
            begin
                if ( line1 == 1'b1 & line2 == 1'b1 ) 
                begin
                    stato = 7;
                end
                else
                begin 
                    stato = 6;
                end
                outp <= line1 ^ line2;
                overflw <= 1'b0;
            end
            5:
            begin
                if ( line1 == 1'b1 | line2 == 1'b1 ) 
                begin
                    stato = 7;
                end
                else
                begin 
                    stato = 6;
                end
                outp <=  ~( line1 ^ line2);
                overflw <= 1'b0;
            end
            6:
            begin
                if ( line1 == 1'b1 & line2 == 1'b1 ) 
                begin
                    stato = 3;
                end
                else
                begin 
                    stato = 0;
                end
                outp <= line1 ^ line2;
                overflw <= 1'b0;
            end
            7:
            begin
                if ( line1 == 1'b1 | line2 == 1'b1 ) 
                begin
                    stato = 3;
                end
                else
                begin 
                    stato = 0;
                end
                outp <=  ~( line1 ^ line2);
                overflw <= 1'b0;
            end
        endcase
    end
end
endmodule 
