remove_design -all

set designer "abc"
set power_preserve_rtl_hier_names "true"
set search_path "/home/abc/dc_shell/lib"  
define_design_lib work -path "work"
set topname "b01_miter"




# The clock input signal name.
set CLK  "clk"
# The reset input signal name.
#set RST  "reset"
# The target clock period in library units.
set CLK_PERIOD 500; 
# The clock uncertainty in library units.
set CLK_UNCERTAINTY  0.001; 

#set link_library   saed90nm_max_nth_lvt_normal.db
#set target_library saed90nm_max_nth_lvt_normal.db

## set link_library   and_or_inv_saed90nm_max_nth_lvt.db
## set target_library and_or_inv_saed90nm_max_nth_lvt.db

## set link_library   saed90nm_max_nth_lvt.db
## set target_library saed90nm_max_nth_lvt.db

set link_library   AND2_INV_FF_saed90nm_max_nth_lvt.db
set target_library AND2_INV_FF_saed90nm_max_nth_lvt.db


analyze -format verilog -lib work "circuits/b01_miter.v"




elaborate $topname -lib work -update

current_design $topname

set auto_wire_load_selection "true"



create_clock $CLK -period $CLK_PERIOD
set_clock_uncertainty $CLK_UNCERTAINTY [all_clocks]
## set_dont_touch_network [all_clocks]


# set_max_delay 0.94 -from N18 -to N10715
# set_max_dynamic_power 1 mW

set_flatten true -design $current_design
#set_ungroup  true  DESIGN_NAME

#set_ungroup  true  [get_designs]
#get_designs


set_optimize_registers
set compile_seqmap_propagate_high_effort "true"

set_switching_activity -toggle_rate 0 -static_probability 0 [find net "error"]

check_design


## compile -map_effort high
compile -ungroup_all  -area_effort high

check_design

#compile_ultra -retime

set sdfout_time_scale 0.001000
#rtl2saif -output "circuits/b01_miter.forward.saif" -design $topname
#write -hierarchy -output "circuits/b01_miter.ddc"
write  -hierarchy -output "circuits/b01_miter_syn.ddc"

write -hier -format verilog -out "circuits/b01_miter_syn.v"

write_saif -propagate -output "circuits/b01_miter_syn.saif"

write_sdf -version 2.1 "circuits/b01_miter_syn.sdf"



#report_timing -nworst 10 > "circuits/b01_miter_syn.timing.report"
report_timing -nworst 40000 > "circuits/b01_miter_syn.timing.report"
report_area -hier > "circuits/b01_miter_syn.area.report"
report_constraint -verbose > "circuits/b01_miter_syn.constraint.report"
report_power -hier > "circuits/b01_miter_syn.power.report"
exit
