// Miter circuit of b01
//
`include "b01.v"

module b01_miter
  (
   // Clock and reset
   clk, rst,
   
   // Internal i/f to top level DC
   line1, line2,

   error
   );


   //
   // inputs
   output                               error  ; 
   //
   input                                clk    ; 
   input                                rst    ; 

   input                                line1  ; 
   input                                line2  ; 

   wire                                line1_f ; 
   wire                                line2_f ; 

   
   // outputs
   wire                         outp           ; 
   wire                         overflw        ; 

   wire                         outp_f         ; 
   wire                         overflw_f      ; 


   // Module instances

b01 b01_err_free(
	.clock   ( clk             ) ,
	.rst   ( rst             ) ,

	.line1   ( line1   ) ,
	.line2   ( line2   ) ,
	.outp    ( outp    ) ,
	.overflw ( overflw ) 
);

b01 b01_faulty(
	.clock   ( clk             ) ,
	.rst   ( rst             ) ,

	.line1   ( line1_f   ) ,
	.line2   ( line2_f   ) ,
	.outp    ( outp_f    ) ,
	.overflw ( overflw_f ) 
);
   //

   // Miter output
   assign error =  (outp          != outp_f         ) 
	         | (overflw       != overflw_f      ) 
                  ;


    assign line2_f    = line2     ;

    assign line1_f       = line1  ;
endmodule
